#version 130


/// Shadow caster material - use VSM
/// ToDo: transparent textures

#pragma vertex_shader

in vec4 vertex;

#ifdef SKINNED
in vec4  weights;
in ivec4 indices;
uniform mat4 boneMatrices[70];
#endif

out float depth;
uniform mat4 transform;
void main() {
	vec4 pos = vertex;
	#ifdef SKINNED
	vec4 weight = weights;
	ivec4 index = indices;
	vec3 blendPosition = vec3(0);
	for(int i=0; i<SKINNED; ++i) {
		blendPosition  += (boneMatrices[index.x] * vertex).xyz * weight.x;
		weight = weight.yzwx;
		index = index.yzwx;
	}
	pos.xyz = blendPosition;
	#endif
	gl_Position = transform * pos;
	depth = gl_Position.z;
}

#pragma fragment_shader
in float depth;
out vec4 fragment;
uniform vec2 bias;	// slopeBias, maxSlopeBias
void main() {
	float z = depth;
	vec2 d = vec2( dFdx(z), dFdy(z) );
	float zSq = z*z + min(bias.y, bias.x * dot(d, vec2(1))); // apply bias to squared value
	fragment = vec4(z, zSq, 0, 0);
}


